namespace NameSpace {
  //! A main class defining a list a elements CS
  template <typename CS>
  class NameSpace::MainClass {
  protected:
    //! a list
    typedef std::list<CS> Sequence;
  };
  
  //! A first class
  template <typename CS>
  class NameSpace::MainClass<CS>::class_one{
    typedef typename Int BaseType;
    //! a first field of type int
    BaseType FirstField;
  };
  
  //! A second class
  template <typename CS>
  class NameSpace::MainClass<CS>::class_two{
    //! a first field of type bool
    typedef typename bool TypeBase;
    //! produces a warning during compilation
    //! This warning appears only when using both a name space and a template 
    //! <CS>, if NameSpace::MainClass<CS>::class_* is replaced by 
    //! NameSpace::MainClass::class_* or if classes aren't in a name space 
    //! then no warning.
    TypeBase FirstField;
  };
}
